#include "TTree.h"
#include "TFile.h"
#include "TH1.h"
#include "TF1.h"
using namespace std;

TH1F *b0;
TH1F *b1;
TH1F *b2;
TH1F *b3;
TH1F *b4;

Double_t fitFun0(Double_t *x, Double_t *par) {
  Double_t xx = x[0];
  Int_t bin = b0->GetXaxis()->FindBin(xx);
  Double_t br0 = par[0]*b0->GetBinContent(bin);
  return br0;
}

Double_t fitFun(Double_t *x, Double_t *par) {
  Double_t xx = x[0];
  Int_t bin = b1->GetXaxis()->FindBin(xx);
  Double_t br1 = par[0]*b1->GetBinContent(bin);
  Double_t br2 = par[1]*b2->GetBinContent(bin);
  Double_t br3 = par[2]*b3->GetBinContent(bin);
  //Double_t br4 = par[2]*b4->GetBinContent(bin);

  return br1 + br2 + br3;
}
Double_t fitFun2(Double_t *x, Double_t *par) {
  Double_t xx = x[0];
  Int_t bin = b1->GetXaxis()->FindBin(xx);
  Double_t br1 = par[0]*b1->GetBinContent(bin);
  Double_t br2 = par[1]*b2->GetBinContent(bin);
  Double_t br3 = par[2]*b3->GetBinContent(bin);
  Double_t br4 = par[3]*b3->GetBinContent(bin);


  return br1 + br2 + br3 + br3;
}


void newErrV2(int iShow){

  gROOT->Reset();
  gROOT->SetStyle("Plain");
  gStyle->SetOptStat(0);
  char  hId[120];
  char  fString[120];

  TFile *hFileOut = new TFile("newMassJ.root","recreate");

  sprintf(fString,"./fit_June-16-2021_Na_Un_SPD_20MeV_final/kstar_m1360_1580_t0_10000.root");
  TFile *hFile0 = new TFile(fString);
  TH1F* hMassAcc1 = (TH1F*)hFile0->Get("hkmpi0_kp_pol0_mkpkmpi0acc1");
  TH1F* hMassAcc2 = (TH1F*)hFile0->Get("hkmpi0_kp_pol0_mkpkmpi0acc2");
  TH1F* hMassAcc3 = (TH1F*)hFile0->Get("hkmpi0_kp_pol0_mkpkmpi0acc3");

  TH1F* hMassAcc145 = (TH1F*)hFile0->Get("hkmpi0_kp_pol45_mkpkmpi0acc1");
  TH1F* hMassAcc245 = (TH1F*)hFile0->Get("hkmpi0_kp_pol45_mkpkmpi0acc2");
  TH1F* hMassAcc345 = (TH1F*)hFile0->Get("hkmpi0_kp_pol45_mkpkmpi0acc3");

  TH1F* hMassAcc190 = (TH1F*)hFile0->Get("hkmpi0_kp_pol90_mkpkmpi0acc1");
  TH1F* hMassAcc290 = (TH1F*)hFile0->Get("hkmpi0_kp_pol90_mkpkmpi0acc2");
  TH1F* hMassAcc390 = (TH1F*)hFile0->Get("hkmpi0_kp_pol90_mkpkmpi0acc3");

  TH1F* hMassAcc1135 = (TH1F*)hFile0->Get("hkmpi0_kp_pol135_mkpkmpi0acc1");
  TH1F* hMassAcc2135 = (TH1F*)hFile0->Get("hkmpi0_kp_pol135_mkpkmpi0acc2");
  TH1F* hMassAcc3135 = (TH1F*)hFile0->Get("hkmpi0_kp_pol135_mkpkmpi0acc3");

  hMassAcc1->Add(hMassAcc1,hMassAcc145);
  hMassAcc1->Add(hMassAcc1,hMassAcc190);
  hMassAcc1->Add(hMassAcc1,hMassAcc1135);

  TH1F* hMassDat1 = (TH1F*)hMassAcc1->Clone("hMassDat1");
  TH1F* hMassDat2 = (TH1F*)hMassAcc2->Clone("hMassDat2");
  TH1F* hMassDat3 = (TH1F*)hMassAcc3->Clone("hMassDat3");

  TH1F* hMassAcc1New = (TH1F*)hMassAcc1->Clone("hMassAcc1");
  TH1F* hMassAcc2New = (TH1F*)hMassAcc2->Clone("hMassAcc2");
  TH1F* hMassAcc3New = (TH1F*)hMassAcc3->Clone("hMassAcc3");

  TH1F* hErrAccFrac1 = (TH1F*)hMassAcc1->Clone("hErrAccFrac3");
  TH1F* hErrAccFrac2 = (TH1F*)hMassAcc2->Clone("hErrAccFrac3");
  TH1F* hErrAccFrac3 = (TH1F*)hMassAcc3->Clone("hErrAccFrac3");


  double nMassBins = hMassAcc1->GetNbinsX();
  int mLow = 1000*hMassAcc1->GetBinLowEdge(1);
  
  if (1 == 1){ int iMass = iShow;
    //for (int iMass = 3; iMass < nMassBins; iMass++) {
    
    mLow = 1000*hMassAcc1->GetBinLowEdge(iMass);
    cout<<"iMass, mLow = "<<iMass<<" , "<<mLow<<endl;
    
    sprintf(fString,"./fit_June-16-2021_Na_Un_SPD_20MeV_final/kstar_m%d_%d_t0_10000.root",mLow,mLow+20);
    TFile *hFile1 = new TFile(fString);

    TH1F* b0a0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosThetaacc");
    TH1F* b1a0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosThetaacc1");
    TH1F* b2a0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosThetaacc2");
    TH1F* b3a0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosThetaacc3");
    TH1F* d1a0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosThetadat");

    TH1F* b0b0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosTheta_Hacc");
    TH1F* b1b0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosTheta_Hacc1");
    TH1F* b2b0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosTheta_Hacc2");
    TH1F* b3b0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosTheta_Hacc3");
    TH1F* d1b0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_cosTheta_Hdat");
    
    TH1F* b0c0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_phiacc");
    TH1F* b1c0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_phiacc1");
    TH1F* b2c0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_phiacc2");
    TH1F* b3c0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_phiacc3");
    TH1F* d1c0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_phidat");

    TH1F* b0d0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_Phiacc");
    TH1F* b1d0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_Phiacc1");
    TH1F* b2d0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_Phiacc2");
    TH1F* b3d0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_Phiacc3");
    TH1F* d1d0 = (TH1F*)hFile1->Get("hkppi0_km_pol0_Phidat");

    TH1F* b0a0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosThetaacc");
    TH1F* b1a0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosThetaacc1");
    TH1F* b2a0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosThetaacc2");
    TH1F* b3a0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosThetaacc3");
    TH1F* d1a0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosThetadat");

    TH1F* b0b0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosTheta_Hacc");
    TH1F* b1b0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosTheta_Hacc1");
    TH1F* b2b0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosTheta_Hacc2");
    TH1F* b3b0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosTheta_Hacc3");
    TH1F* d1b0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_cosTheta_Hdat");
    
    TH1F* b0c0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_phiacc");
    TH1F* b1c0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_phiacc1");
    TH1F* b2c0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_phiacc2");
    TH1F* b3c0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_phiacc3");
    TH1F* d1c0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_phidat");

    TH1F* b0d0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_Phiacc");
    TH1F* b1d0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_Phiacc1");
    TH1F* b2d0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_Phiacc2");
    TH1F* b3d0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_Phiacc3");
    TH1F* d1d0e = (TH1F*)hFile1->Get("hkmpi0_kp_pol0_Phidat");
    
    TH1F* b0a45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosThetaacc");
    TH1F* b1a45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosThetaacc1");
    TH1F* b2a45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosThetaacc2");
    TH1F* b3a45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosThetaacc3");
    TH1F* d1a45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosThetadat");
    
    TH1F* b0b45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosTheta_Hacc");
    TH1F* b1b45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosTheta_Hacc1");
    TH1F* b2b45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosTheta_Hacc2");
    TH1F* b3b45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosTheta_Hacc3");
    TH1F* d1b45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_cosTheta_Hdat");
    
    TH1F* b0c45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_phiacc");
    TH1F* b1c45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_phiacc1");
    TH1F* b2c45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_phiacc2");
    TH1F* b3c45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_phiacc3");
    TH1F* d1c45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_phidat");

    TH1F* b0d45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_Phiacc");
    TH1F* b1d45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_Phiacc1");
    TH1F* b2d45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_Phiacc2");
    TH1F* b3d45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_Phiacc3");
    TH1F* d1d45 = (TH1F*)hFile1->Get("hkppi0_km_pol45_Phidat");

    ////////
    TH1F* b0a45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosThetaacc");
    TH1F* b1a45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosThetaacc1");
    TH1F* b2a45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosThetaacc2");
    TH1F* b3a45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosThetaacc3");
    TH1F* d1a45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosThetadat");
    
    TH1F* b0b45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosTheta_Hacc");
    TH1F* b1b45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosTheta_Hacc1");
    TH1F* b2b45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosTheta_Hacc2");
    TH1F* b3b45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosTheta_Hacc3");
    TH1F* d1b45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_cosTheta_Hdat");
    
    TH1F* b0c45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_phiacc");
    TH1F* b1c45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_phiacc1");
    TH1F* b2c45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_phiacc2");
    TH1F* b3c45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_phiacc3");
    TH1F* d1c45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_phidat");

    TH1F* b0d45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_Phiacc");
    TH1F* b1d45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_Phiacc1");
    TH1F* b2d45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_Phiacc2");
    TH1F* b3d45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_Phiacc3");
    TH1F* d1d45e = (TH1F*)hFile1->Get("hkmpi0_kp_pol45_Phidat");

    ///////////
    
    TH1F* b0a90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosThetaacc");
    TH1F* b1a90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosThetaacc1");
    TH1F* b2a90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosThetaacc2");
    TH1F* b3a90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosThetaacc3");
    TH1F* d1a90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosThetadat");
    
    TH1F* b0b90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosTheta_Hacc");
    TH1F* b1b90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosTheta_Hacc1");
    TH1F* b2b90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosTheta_Hacc2");
    TH1F* b3b90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosTheta_Hacc3");
    TH1F* d1b90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_cosTheta_Hdat");
    
    TH1F* b0c90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_phiacc");
    TH1F* b1c90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_phiacc1");
    TH1F* b2c90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_phiacc2");
    TH1F* b3c90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_phiacc3");
    TH1F* d1c90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_phidat");

    TH1F* b0d90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_Phiacc");
    TH1F* b1d90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_Phiacc1");
    TH1F* b2d90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_Phiacc2");
    TH1F* b3d90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_Phiacc3");
    TH1F* d1d90 = (TH1F*)hFile1->Get("hkppi0_km_pol90_Phidat");

    /////////////

    TH1F* b0a90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosThetaacc");
    TH1F* b1a90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosThetaacc1");
    TH1F* b2a90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosThetaacc2");
    TH1F* b3a90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosThetaacc3");
    TH1F* d1a90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosThetadat");
    
    TH1F* b0b90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosTheta_Hacc");
    TH1F* b1b90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosTheta_Hacc1");
    TH1F* b2b90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosTheta_Hacc2");
    TH1F* b3b90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosTheta_Hacc3");
    TH1F* d1b90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_cosTheta_Hdat");
    
    TH1F* b0c90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_phiacc");
    TH1F* b1c90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_phiacc1");
    TH1F* b2c90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_phiacc2");
    TH1F* b3c90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_phiacc3");
    TH1F* d1c90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_phidat");

    TH1F* b0d90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_Phiacc");
    TH1F* b1d90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_Phiacc1");
    TH1F* b2d90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_Phiacc2");
    TH1F* b3d90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_Phiacc3");
    TH1F* d1d90e = (TH1F*)hFile1->Get("hkmpi0_kp_pol90_Phidat");

    ////////////
    
    TH1F* b0a135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosThetaacc");
    TH1F* b1a135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosThetaacc1");
    TH1F* b2a135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosThetaacc2");
    TH1F* b3a135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosThetaacc3");
    TH1F* d1a135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosThetadat");
    
    TH1F* b0b135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosTheta_Hacc");
    TH1F* b1b135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosTheta_Hacc1");
    TH1F* b2b135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosTheta_Hacc2");
    TH1F* b3b135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosTheta_Hacc3");
    TH1F* d1b135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_cosTheta_Hdat");
    
    TH1F* b0c135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_phiacc");
    TH1F* b1c135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_phiacc1");
    TH1F* b2c135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_phiacc2");
    TH1F* b3c135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_phiacc3");
    TH1F* d1c135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_phidat");

    TH1F* b0d135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_Phiacc");
    TH1F* b1d135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_Phiacc1");
    TH1F* b2d135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_Phiacc2");
    TH1F* b3d135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_Phiacc3");
    TH1F* d1d135 = (TH1F*)hFile1->Get("hkppi0_km_pol135_Phidat");

    ////////////

    TH1F* b0a135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosThetaacc");
    TH1F* b1a135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosThetaacc1");
    TH1F* b2a135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosThetaacc2");
    TH1F* b3a135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosThetaacc3");
    TH1F* d1a135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosThetadat");
    
    TH1F* b0b135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosTheta_Hacc");
    TH1F* b1b135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosTheta_Hacc1");
    TH1F* b2b135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosTheta_Hacc2");
    TH1F* b3b135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosTheta_Hacc3");
    TH1F* d1b135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_cosTheta_Hdat");
    
    TH1F* b0c135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_phiacc");
    TH1F* b1c135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_phiacc1");
    TH1F* b2c135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_phiacc2");
    TH1F* b3c135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_phiacc3");
    TH1F* d1c135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_phidat");

    TH1F* b0d135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_Phiacc");
    TH1F* b1d135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_Phiacc1");
    TH1F* b2d135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_Phiacc2");
    TH1F* b3d135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_Phiacc3");
    TH1F* d1d135e = (TH1F*)hFile1->Get("hkmpi0_kp_pol135_Phidat");


    ////////////
    
    TH1F* b0a = (TH1F*)b0a0->Clone("b0a");
    TH1F* b0b = (TH1F*)b0b0->Clone("b0b");
    TH1F* b0c = (TH1F*)b0c0->Clone("b0c");
    TH1F* b0d = (TH1F*)b0d0->Clone("b0d");

    TH1F* b1a = (TH1F*)b1a0->Clone("b1a");
    TH1F* b1b = (TH1F*)b1b0->Clone("b1b");
    TH1F* b1c = (TH1F*)b1c0->Clone("b1c");
    TH1F* b1d = (TH1F*)b1d0->Clone("b1d");
    
    TH1F* b2a = (TH1F*)b2a0->Clone("b1a");
    TH1F* b2b = (TH1F*)b2b0->Clone("b1b");
    TH1F* b2c = (TH1F*)b2c0->Clone("b1c");
    TH1F* b2d = (TH1F*)b2d0->Clone("b1d");
    
    TH1F* b3a = (TH1F*)b3a0->Clone("b3a");
    TH1F* b3b = (TH1F*)b3b0->Clone("b3b");
    TH1F* b3c = (TH1F*)b3c0->Clone("b3c");
    TH1F* b3d = (TH1F*)b3d0->Clone("b3d");

    TH1F* d1a = (TH1F*)d1a0->Clone("d1a");
    TH1F* d1b = (TH1F*)d1b0->Clone("d1b");
    TH1F* d1c = (TH1F*)d1c0->Clone("d1c");
    TH1F* d1d = (TH1F*)d1d0->Clone("d1d");

    cout<<"t:1"<<endl;
    b1a->Add(b1a,b1a45);  b1a->Add(b1a,b1a90); b1a->Add(b1a,b1a135);b1a->Add(b1a,b1a0e);b1a->Add(b1a,b1a45e);b1a->Add(b1a,b1a90e);b1a->Add(b1a,b1a135e);
    b2a->Add(b2a,b2a45);  b2a->Add(b2a,b2a90); b2a->Add(b2a,b2a135);b2a->Add(b2a,b2a0e);b2a->Add(b2a,b2a45e);b2a->Add(b2a,b2a90e);b2a->Add(b2a,b2a135e);
    b3a->Add(b3a,b3a45);  b3a->Add(b3a,b3a90); b3a->Add(b3a,b3a135);b3a->Add(b3a,b3a0e);b3a->Add(b3a,b3a45e);b3a->Add(b3a,b3a90e);b3a->Add(b3a,b3a135e);
    b0a->Add(b0a,b0a45);  b0a->Add(b0a,b0a90); b0a->Add(b0a,b0a135);b0a->Add(b0a,b0a0e);b0a->Add(b0a,b0a45e);b0a->Add(b0a,b0a90e);b0a->Add(b0a,b0a135e);
    d1a->Add(d1a,d1a45);  d1a->Add(d1a,d1a90); d1a->Add(d1a,d1a135);d1a->Add(d1a,d1a0e);d1a->Add(d1a,d1a45e);d1a->Add(d1a,d1a90e);d1a->Add(d1a,d1a135e);

    cout<<"t:2"<<endl;
    b1b->Add(b1b,b1b45);  b1b->Add(b1b,b1b90); b1b->Add(b1b,b1b135);b1b->Add(b1b,b1b0e);b1b->Add(b1b,b1b45e);b1b->Add(b1b,b1b90e);b1b->Add(b1b,b1b135e);
    b2b->Add(b2b,b2b45);  b2b->Add(b2b,b2b90); b2b->Add(b2b,b2b135);b2b->Add(b2b,b2b0e);b2b->Add(b2b,b2b45e);b2b->Add(b2b,b2b90e);b2b->Add(b2b,b2b135e);
    b3b->Add(b3b,b3b45);  b3b->Add(b3b,b3b90); b3b->Add(b3b,b3b135);b3b->Add(b3b,b3b0e);b3b->Add(b3b,b3b45e);b3b->Add(b3b,b3b90e);b3b->Add(b3b,b3b135e);
    b0b->Add(b0b,b0b45);  b0b->Add(b0b,b0b90); b0b->Add(b0b,b0b135);b0b->Add(b0b,b0b0e);b0b->Add(b0b,b0b45e);b0b->Add(b0b,b0b90e);b0b->Add(b0b,b0b135e);
    d1b->Add(d1b,d1b45);  d1b->Add(d1b,d1b90); d1b->Add(d1b,d1b135);d1b->Add(d1b,d1b0e);d1b->Add(d1b,d1b45e);d1b->Add(d1b,d1b90e);d1b->Add(d1b,d1b135e);
    
    b0c->Add(b0c,b0c45);  b0c->Add(b0c,b0c90); b0c->Add(b0c,b0c135);b0c->Add(b0c,b0c0e);b0c->Add(b0c,b0c45e);b0c->Add(b0c,b0c90e);b0c->Add(b0c,b0c135e);
    cout<<"t:3"<<endl;
    b1c->Add(b1c,b1c45);  b1c->Add(b1c,b1c90); b1c->Add(b1c,b1c135);
    cout<<"t:3a1"<<endl;
    b1c->Add(b1c,b1c0e);
    cout<<"t:3a2"<<endl;
    //b1b->Add(b1c,b1c45e);//!!
    cout<<"t:3a3"<<endl;
    b1c->Add(b1c,b1c90e);
    cout<<"t:3a4"<<endl;
    b1c->Add(b1c,b1c135e);
    cout<<"t:3b"<<endl;
    b2c->Add(b2c,b2c45);  b2c->Add(b2c,b2c90); b2c->Add(b2c,b2c135);
    cout<<"t:3b1"<<endl;
    b2c->Add(b2c,b2c0e);
    cout<<"t:3b2"<<endl;
    //b2b->Add(b2c,b2c45e);
    cout<<"t:3b3"<<endl;
    b2c->Add(b2c,b2c90e);b2c->Add(b2c,b2c135e);
    b3c->Add(b3c,b3c45);  b3c->Add(b3c,b3c90); b3c->Add(b3c,b3c135);b3c->Add(b3c,b3c0e);
    //b3b->Add(b3c,b3c45e);
    b3c->Add(b3c,b3c90e);b3c->Add(b3c,b3c135e);
    d1c->Add(d1c,d1c45);  d1c->Add(d1c,d1c90); d1c->Add(d1c,d1c135);d1c->Add(d1c,d1c0e);
    //d1b->Add(d1c,d1c45e);
    d1c->Add(d1c,d1c90e);d1c->Add(d1c,d1c135e);

    cout<<"t:4"<<endl;
    b1d->Add(b1d,b1d45);  b1d->Add(b1d,b1d90); b1d->Add(b1d,b1d135);b1d->Add(b1d,b1d0e);b1d->Add(b1d,b1d45e);b1d->Add(b1d,b1d90e);b1d->Add(b1d,b1d135e);
    cout<<"t:42"<<endl;
    b2d->Add(b2d,b2d45);  b2d->Add(b2d,b2d90); b2d->Add(b2d,b2d135);b2d->Add(b2d,b2d0e);b2d->Add(b2d,b2d45e);b2d->Add(b2d,b2d90e);b2d->Add(b2d,b2d135e);
    b3d->Add(b3d,b3d45);  b3d->Add(b3d,b3d90); b3d->Add(b3d,b3d135);b3d->Add(b3d,b3d0e);b3d->Add(b3d,b3d45e);b3d->Add(b3d,b3d90e);b3d->Add(b3d,b3d135e);
    b0d->Add(b0d,b0d45);  b0d->Add(b0d,b0d90); b0d->Add(b0d,b0d135);b0d->Add(b0d,b0d0e);b0d->Add(b0d,b0d45e);b0d->Add(b0d,b0d90e);b0d->Add(b0d,b0d135e);
    d1d->Add(d1d,d1d45);  d1d->Add(d1d,d1d90); d1d->Add(d1d,d1d135);d1d->Add(d1d,d1d0e);d1d->Add(d1d,d1d45e);d1d->Add(d1d,d1d90e);d1d->Add(d1d,d1d135e);
    
    int na = b1a->GetNbinsX();
    int nb = b1b->GetNbinsX();
    int nc = b1c->GetNbinsX();
    int nd = b1d->GetNbinsX();
    
    b0 = new TH1F("b0","",56,0.0,56.0);
    b1 = new TH1F("b1","",56,0.0,56.0);
    b2 = new TH1F("b2","",56,0.0,56.0);
    b3 = new TH1F("b3","",56,0.0,56.0);
    b4 = new TH1F("b4","",56,0.0,56.0);
    TH1F *d1 = new TH1F("d1","",56,0.0,56.0);
    
    for (int ia = 1; ia <= na; ia++) {
      float valTmp = b1a->GetBinContent(ia);
      float errTmp = b1a->GetBinError(ia);
      b1->SetBinContent(ia,valTmp);
      b1->SetBinError(ia,errTmp);
      valTmp = b2a->GetBinContent(ia);
      errTmp = b2a->GetBinError(ia);
      b2->SetBinContent(ia,valTmp);
      b2->SetBinError(ia,errTmp);
      valTmp = b3a->GetBinContent(ia);
      errTmp = b3a->GetBinError(ia);
      b3->SetBinContent(ia,valTmp);
      b3->SetBinError(ia,errTmp);

      valTmp = b0a->GetBinContent(ia);
      errTmp = b0a->GetBinError(ia);
      b0->SetBinContent(ia,valTmp);
      b0->SetBinError(ia,errTmp);

      valTmp = d1a->GetBinContent(ia);
      errTmp = d1a->GetBinError(ia);
      d1->SetBinContent(ia,valTmp);
      d1->SetBinError(ia,errTmp);
    }
    for (int ib = 1; ib <= nb; ib++) {
      float valTmp = b1b->GetBinContent(ib);
      float errTmp = b1b->GetBinError(ib);
      b1->SetBinContent(na+ib,valTmp);
      b1->SetBinError(na+ib,errTmp);
      valTmp = b2b->GetBinContent(ib);
      errTmp = b2b->GetBinError(ib);
      b2->SetBinContent(na+ib,valTmp);
      b2->SetBinError(na+ib,errTmp);
      valTmp = b3b->GetBinContent(ib);
      errTmp = b3b->GetBinError(ib);
      b3->SetBinContent(na+ib,valTmp);
      b3->SetBinError(na+ib,errTmp);


      valTmp = b0b->GetBinContent(ib);
      errTmp = b0b->GetBinError(ib);
      b0->SetBinContent(na+ib,valTmp);
      b0->SetBinError(na+ib,errTmp);

      valTmp = d1b->GetBinContent(ib);
      errTmp = d1b->GetBinError(ib);
      d1->SetBinContent(na+ib,valTmp);
      d1->SetBinError(na+ib,errTmp);
    }
    for (int ic = 1; ic <= nc; ic++) {
      float valTmp = b1c->GetBinContent(ic);
      float errTmp = b1c->GetBinError(ic);
      b1->SetBinContent(na+nb+ic,valTmp);
      b1->SetBinError(na+nb+ic,errTmp);
      valTmp = b2c->GetBinContent(ic);
      errTmp = b2c->GetBinError(ic);
      b2->SetBinContent(na+nb+ic,valTmp);
      b2->SetBinError(na+nb+ic,errTmp);
      valTmp = b3c->GetBinContent(ic);
      errTmp = b3c->GetBinError(ic);
      b3->SetBinContent(na+nb+ic,valTmp);
      b3->SetBinError(na+nb+ic,errTmp);

      valTmp = b0c->GetBinContent(ic);
      errTmp = b0c->GetBinError(ic);
      b0->SetBinContent(na+nb+ic,valTmp);
      b0->SetBinError(na+nb+ic,errTmp);


      valTmp = d1c->GetBinContent(ic);
      errTmp = d1c->GetBinError(ic);
      d1->SetBinContent(na+nb+ic,valTmp);
      d1->SetBinError(na+nb+ic,errTmp);
    }
    for (int id = 1; id <= nd; id++) {
      float valTmp = b1d->GetBinContent(id);
      float errTmp = b1d->GetBinError(id);
      b1->SetBinContent(na+nb+nc+id,valTmp);
      b1->SetBinError(na+nb+nc+id,errTmp);
      valTmp = b2d->GetBinContent(id);
      errTmp = b2d->GetBinError(id);
      b2->SetBinContent(na+nb+nc+id,valTmp);
      b2->SetBinError(na+nb+nc+id,errTmp);
      valTmp = b3d->GetBinContent(id);
      errTmp = b3d->GetBinError(id);
      b3->SetBinContent(na+nb+nc+id,valTmp);
      b3->SetBinError(na+nb+nc+id,errTmp);

      valTmp = b0d->GetBinContent(id);
      errTmp = b0d->GetBinError(id);
      b0->SetBinContent(na+nb+nc+id,valTmp);
      b0->SetBinError(na+nb+nc+id,errTmp);


      valTmp = d1d->GetBinContent(id);
      errTmp = d1d->GetBinError(id);
      d1->SetBinContent(na+nb+nc+id,valTmp);
      d1->SetBinError(na+nb+nc+id,errTmp);
    }
    
    
    TH1F *bTot = (TH1F*)b1->Clone("bTot");
    
    bTot->Add(b1,b2);
    bTot->Add(bTot,b3);
    bTot->Add(bTot,b4);


    TH1F *dTot = (TH1F*)d1->Clone("dTot");
    
    TF1 *ftot2 = new TF1("ftot2",fitFun,-1000,1000,4);
    TF1 *ftot = new TF1("ftot",fitFun,-1000,1000,3);
    TF1 *ftot0 = new TF1("ftot0",fitFun0,-1000,1000,1);
    ftot->SetParameter(0,1.0);
    ftot->SetParameter(1,1.0);
    ftot->SetParameter(2,1.0);

    //ftot->SetParLimits(0,0.9,1.1);
    //ftot->SetParLimits(1,0.9,1.1);
    //ftot->SetParLimits(2,0.9,1.1);

    //ftot2->SetParameter(1,10.0);
    //ftot->FixParameter(1,0);
    //ftot->FixParameter(2,0);
    //dTot->Fit("ftot","");   

    bTot->Fit("ftot0","R","",0,9);   
    return;
    double par00 = ftot0->GetParameter(0);
    ftot->SetParameter(0,par00);
    ftot->SetParameter(1,par00);
    ftot->SetParameter(2,par00);
    dTot->Fit("ftot","");   


    //ftot->SetParameter(0,ftot2->GetParameter(1));
    //ftot->SetParameter(1,ftot2->GetParameter(1));
    //ftot->SetParameter(2,ftot2->GetParameter(1));
    //dTot->Fit("ftot","");   

    dTot->SetMinimum(0);
    dTot->SetLineColor(1);
    dTot->SetLineWidth(1);
    dTot->Draw();
    b1->SetLineColor(2);
    b2->SetLineColor(3);
    b3->SetLineColor(4);
    b4->SetLineColor(7);

    
    b1->SetLineWidth(2);
    b2->SetLineWidth(2);
    b3->SetLineWidth(2);
    b4->SetLineWidth(7);

    
    b1->Draw("same");
    b2->Draw("same");
    b3->Draw("same");
    b4->Draw("same");

    //double b1Err = ftot->GetParError(0)/ftot->GetParameter(0);
    //double b2Err = ftot->GetParError(1)/ftot->GetParameter(1);
    //double b3Err = ftot->GetParError(2)/ftot->GetParameter(2);
    
    //double acc1Val = hMassAcc1New->GetBinContent(iMass);
    //double acc1Err = hMassAcc1New->GetBinError(iMass);
    //double acc1ErrNew = b1Err*acc1Val;
    // hMassAcc1New->SetBinError(iMass,acc1ErrNew);

    //double acc2Val = hMassAcc2New->GetBinContent(iMass);
    //double acc2Err = hMassAcc2New->GetBinError(iMass);
    //double acc2ErrNew = b2Err*acc2Val;
    //hMassAcc2New->SetBinError(iMass,acc2ErrNew);

    //double acc3Val = hMassAcc3New->GetBinContent(iMass);
    //double acc3Err = hMassAcc3New->GetBinError(iMass);
    //double acc3ErrNew = b3Err*acc3Val;
    //hMassAcc3New->SetBinError(iMass,acc3ErrNew);

    //if (acc1Err > acc1Val) acc1Err = acc1Val; 
    //if (acc2Err > acc2Val) acc2Err = acc2Val; 
    // if (acc3Err > acc3Val) acc3Err = acc3Val; 

    //hErrAccFrac1->SetBinContent(iMass,acc1Err/acc1Val);
    //hErrAccFrac2->SetBinContent(iMass,acc2Err/acc2Val);
    //hErrAccFrac3->SetBinContent(iMass,acc3Err/acc3Val);
  }

  //hMassAcc1->SetLineColor(1);
  //hMassAcc1->SetLineWidth(2);
  //hMassAcc1New->SetLineColor(2);
  //hMassAcc1New->SetLineWidth(2);
  if (iShow == 1){
    //hMassAcc1New->Draw("e1");
    //hMassAcc1->Draw("same");
  }

  //hMassAcc2->SetLineColor(1);
  //hMassAcc2->SetLineWidth(2);
  //hMassAcc2New->SetLineColor(2);
  //hMassAcc2New->SetLineWidth(2);
  if (iShow == 2){
    //hMassAcc2New->Draw("e1");
    //hMassAcc2->Draw("same");
  }

  //hMassAcc3->SetLineColor(1);
  //hMassAcc3->SetLineWidth(2);
  //hMassAcc3New->SetLineColor(2);
  //hMassAcc3New->SetLineWidth(2);
  if (iShow == 3){
    //hMassAcc3New->Draw("e1");
    //hMassAcc3->Draw("same");
  }

  //hErrAccFrac1->SetLineColor(2);
  //hErrAccFrac1->SetLineWidth(4);
  //hErrAccFrac2->SetLineColor(3);
  //hErrAccFrac2->SetLineWidth(3);
  //hErrAccFrac3->SetLineColor(4);
  //hErrAccFrac1->SetLineWidth(2);
  //hErrAccFrac1->GetYaxis()->SetTitle("standard deviation");
  if (iShow == 11){
    //hErrAccFrac1->Draw("hist");
    //hErrAccFrac2->Draw("samehist");
    //hErrAccFrac3->Draw("samehist");
  }
  //hFileOut->cd();
  //hMassAcc1New->Write();
  //hMassAcc2New->Write();
  //hMassAcc3New->Write();

}

